Subject: Re: [PATCH v2 2/3] nvme-tcp: support specifying the congestion-control

From: Jakub Kicinski <[email-masked]>
Date: Mon, 28 Mar 2022 21:33:53 -0700

On Tue, 29 Mar 2022 10:48:06 +0800 Mingbao Sun wrote:
> A server in a data-center with the following 2 NICs:
> 
>     - NIC_fron-end, for interacting with clients through WAN
>       (high latency, ms-level)
> 
>     - NIC_back-end, for interacting with NVMe/TCP target through LAN
>       (low latency, ECN-enabled, ideal for dctcp)
> 
> This server interacts with clients (handling requests) via the fron-end
> network and accesses the NVMe/TCP storage via the back-end network.
> This is a normal use case, right?

Well, if you have clearly separated networks you can set the congestion
control algorithm per route, right? man ip-route, search congctl.

> For the client devices, we can’t determine their congestion-control.
> But normally it’s cubic by default (per the CONFIG_DEFAULT_TCP_CONG).
> So if we change the default congestion control on the server to dctcp
> on behalf of the NVMe/TCP traffic of the LAN side, it could at the
> same time change the congestion-control of the front-end sockets
> to dctcp while the congestion-control of the client-side is cubic.
> So this is an unexpected scenario.
> 
> In addition, distributed storage products like the following also have
> the above problem:
> 
>     - The product consists of a cluster of servers.
> 
>     - Each server serves clients via its front-end NIC
>      (WAN, high latency).
> 
>     - All servers interact with each other via NVMe/TCP via back-end NIC
>      (LAN, low latency, ECN-enabled, ideal for dctcp).